# NgDynaform

Beakout project to develop Dynamic Form Builder module.

## General options for each control ##

### Common field metadata properties ###

| Property           	| Description                                                                   	| Default / Notes                                      	|
|--------------------	|-------------------------------------------------------------------------------	|------------------------------------------------------	|
| name               	| The FormControl name                                                          	| OBLIGATORY                                           	|
| type               	| The control type                                                              	| Text                                                 	|
| label              	| The controls's label                                                          	| UnCamelCased and spaced version of name              	|
| value              	| The control's initial value                                                                              	| Empty string                                         	|
| checkedValue       	| Value when checked*                                                           	| Checkboxes / Checkbuttons only                       	|
| default            	| Default value                                                                 	|                                                      	|
| placeholder        	| Optional placeholder text                                                     	|                                                      	|
| class              	| CSS classes to apply                                                          	| Single class (string) or array of classes (string[]) 	|
| id                 	| CSS id to apply                                                               	|                                                      	|
| disabled           	| Whether field is disbled                                                      	|                                                      	|
| change             	| Name of function in host component to call when value changes                 	|                                                      	|
| source             	| Location of data in model                                                      	| Same name and path. Used by model-mapper.            	|
| before             	| Ordering instruction - move before <name of another control in group>         	|                                                      	|
| after              	| Ordering instruction - move after <name of another control in group>          	|                                                      	|
| validators         	| Array of validator functions - following Angular FormControl API              	|                                                      	|
| asyncValidators    	| Array of async validator functions - following Angular FormControl API        	|                                                      	|
| valFailureMessages 	| Validation failure messages - display appropriate message if validation fails 	|                                                      	|
|                    	|                                                                               	|                                                      	|

### Options metadata (selects, radios, checkbutton groups, etc) ###

Supply an array of values, an array of [key, label] pairs, or an array of { label: <LABEL>, value: <VALUE> } objects. If you supply an array of values, each value is used as both the options value and label.

## Grouping related controls using containers ##

Blah, de blah blat. TO ADD.

### Seeding groups with shared options ###

### Repeating groups ###

## The built-in model mapper ##

TO ADD.

